// C3DModel Class Header
// 
// Description: class that handles loading and drawing pre-created .iv models
//

#pragma once

// includes
#include "stdafx.h"
#include "InventorParser_v3.0.h"
#include "GU_v2.2.h"
#include <string>
using namespace std;


///////////////////////////////////////////////////////////////////
// C3DModel Class
// Description:	handles loading and drawing inventor models
///////////////////////////////////////////////////////////////////
class C3DModel  
{
public:
					C3DModel()						{ m_dlDisplayList = NULL; }
	virtual			~C3DModel()						{}

			void	Draw()							{ if (m_dlDisplayList) glCallList(m_dlDisplayList); }
			bool	Load(string strFilename);
	
	
// member variables
private:

	GLuint		m_dlDisplayList;
	int			m_nSizeInPixels;

public:
	CBox		m_cModelExtents;  // model extents
};
