// CEnemyCar Class Implementation
// 
// Description : inherits from CCar, adds driving AI
//

// includes
#include "stdafx.h"
#include "EnemyCar.h"
	

///////////////////////////////////////////////////////////////////
// CEnemyCar::Update(int* pEnv)
// Description:	generic update, runs AI
///////////////////////////////////////////////////////////////////
void CEnemyCar::Update(int* pEnv)
{
	CCar::Update();
	FollowCenterOfTrack();
	Move(pEnv);
	if(GetSpeed() == 0.0f)
		TurnRight();
}

///////////////////////////////////////////////////////////////////
// CEnemyCar::Draw()
// Description:	draws the car in the correct position, orientation
///////////////////////////////////////////////////////////////////
void CEnemyCar::Draw()
{
	glPushMatrix();
		glTranslatef(GetPos().data[0], GetPos().data[1], GetPos().data[2]);
		if(GetDir().data[1] > 0.0f)
			glRotatef(57.29578f * GUAngleBetween(GetDir(), CPnt(-1.0f, 0.0f, 0.0f)), 0.0f, 0.0f, -1.0f);
		else
			glRotatef(57.29578f * GUAngleBetween(GetDir(), CPnt(-1.0f, 0.0f, 0.0f)), 0.0f, 0.0f, 1.0f);
		CCar::Draw();
	glPopMatrix();
}

///////////////////////////////////////////////////////////////////
// CEnemyCar::FollowCenterOfTrack()
// Description:	AI to try to follow center of track
///////////////////////////////////////////////////////////////////
void CEnemyCar::FollowCenterOfTrack()
{
	if(GetPos().data[0] < -660.0f)
	{
		if(((GetPos().data[0] + 660.0f) * (GetPos().data[0] + 660.0f) + GetPos().data[1] * GetPos().data[1]) > m_fYPos*m_fYPos)
		{
			TurnLeft();
			SpeedUp();
		}
		else if(((GetPos().data[0] + 660.0f) * (GetPos().data[0] + 660.0f) + GetPos().data[1] * GetPos().data[1]) < m_fYPos*m_fYPos)
		{
			//TurnRight();
			SpeedUp();
		}
		else
		{
			SpeedUp();
		}
	}
	else if(GetPos().data[0] >= 660.0f)
	{

		if(((GetPos().data[0] - 660.0f) * (GetPos().data[0] - 660.0f) + GetPos().data[1] * GetPos().data[1]) < m_fYPos*m_fYPos)
		{
			//TurnRight();
			SpeedUp();
		}
		else if(((GetPos().data[0] - 660.0f) * (GetPos().data[0] - 660.0f) + GetPos().data[1] * GetPos().data[1]) > m_fYPos*m_fYPos)
		{
			TurnLeft();
			SpeedUp();
		}
		else
		{
			SpeedUp();
		}
	}
	else if(GetPos()[1] < 0.0f)
	{
		SpeedUp();
		m_fYPos = GetPos()[1];

	}
	else if(GetPos()[1] > 0.0f)
	{
		SpeedUp();
		m_fYPos = GetPos()[1];
	}
}
