
#include "stdafx.h"
#include "OpenGLControlBase.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif 

using namespace std;

COpenGLManager* g_pManager = new COpenGLManager;
void	KillOpenGLManager()
{
	delete g_pManager;
}

int	MyChoosePixelFormat(HDC hDC, PIXELFORMATDESCRIPTOR& pfd)
{
	if (!g_pManager->IsHardwareAccel())
	{
		int nMax = DescribePixelFormat(hDC, 1, sizeof(PIXELFORMATDESCRIPTOR), &pfd);
		for (int i=1; i <= nMax; i++)
		{
			DescribePixelFormat(hDC, i, sizeof(PIXELFORMATDESCRIPTOR), &pfd);
			if ((pfd.dwFlags & PFD_DOUBLEBUFFER)		&&
				(pfd.dwFlags & PFD_SUPPORT_OPENGL)		&&
			//	(pfd.dwFlags & PFD_DEPTH_DONTCARE)		&&
				(pfd.dwFlags & PFD_DRAW_TO_WINDOW)		&&
				(pfd.dwFlags & PFD_GENERIC_FORMAT)		&&
				(pfd.iPixelType == PFD_TYPE_RGBA)		&&
				(pfd.cColorBits >= 16))//					&&
			//	(pfd.cDepthBits == 0))
			{
				return i;
			}
		}
	}
	else
		return ChoosePixelFormat(hDC, &pfd);
	AfxMessageBox("Failed to initialize Software OpenGL");
	return ChoosePixelFormat(hDC, &pfd);
}

IMPLEMENT_DYNAMIC(COpenGLControlBase,CWnd); 


//		   Name:	COpenGLControlBase
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

COpenGLControlBase::COpenGLControlBase()
: m_cMenu(this) 
{
	m_bMousePressedInThisWindow  = false;
	m_nCode	=	0;
	m_hRC = NULL;
	m_hDC = NULL;
	m_pDC = NULL;
    
	static BOOL Registered=FALSE;
    if (!Registered)
         Registered=RegisterOpenGLWindowClass();
	m_bAnimating	=	false;
	m_bInitialized	=	false;
}
 
COpenGLControlBase::~COpenGLControlBase()
{
}

BEGIN_MESSAGE_MAP(COpenGLControlBase, CWnd)
    //{{AFX_MSG_MAP(COpenGLControlBase)
    ON_WM_DESTROY()
    ON_WM_SIZE()
    ON_WM_PAINT()
    ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MBUTTONDOWN()
	ON_WM_MBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KEYDOWN()
	ON_WM_SYSKEYDOWN()
	ON_WM_SYSKEYUP()
	ON_WM_KEYUP()
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONDBLCLK() 
	ON_WM_RBUTTONDBLCLK()
	ON_WM_NCPAINT()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
//	ON_COMMAND_RANGE( ID_WINU_MENU, ID_WINU_MENULAST,  OnMenu)
END_MESSAGE_MAP()

//		   Name: PreCreateWindow(CREATESTRUCT& cs) 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

BOOL COpenGLControlBase::PreCreateWindow(CREATESTRUCT& cs) 
{
    cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN | CS_OWNDC;
    return CWnd::PreCreateWindow(cs);
}

//		   Name: PreSubclassWindow()
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::PreSubclassWindow() 
{
   ASSERT(m_hWnd);
   // Window class must not have style CS_PARENTDC
   ASSERT((GetClassLong(m_hWnd,GCL_STYLE)&CS_PARENTDC)==0); 
   // Must add these styles to use OpenGL
   ModifyStyle(0,WS_CLIPSIBLINGS|WS_CLIPCHILDREN);

   InitializeOpenGLWindow();

   CRect Rect;
   GetClientRect(&Rect);

   // If we are subclassing an existing window 
   // we might have missed the WM_SIZE message
   if (!Rect.IsRectEmpty())
   {
      OnSize( 0, Rect.Width(), Rect.Height() );
   }
   CWnd::PreSubclassWindow();
}

//		   Name:	OnPaint() 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation
 
void COpenGLControlBase::OnPaint() 
{
//	TRACE("****OnPaint***\n");
	if( !m_bInitialized )
	{
		BeginOpenGLDrawing();
		glViewport(0,0,m_nWindowWidth, m_nWindowHeight);
		vWindowResized(m_nWindowWidth, m_nWindowHeight);
		vWindowInitialExposure();
		m_bInitialized = true;
		EndOpenGLDrawing();
	}
	CPaintDC DC(this);
	Draw();
}   


//		   Name:	OnEraseBkgnd(CDC* pDC) 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

BOOL COpenGLControlBase::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE; // Don't clear background, OpenGL will
}


//		   Name:	OnDestroy() 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnDestroy() 
{
    UninitializeOpenGLWindow();
    CWnd::OnDestroy();
}


//		   Name:	SetupPixelFormat(HDC hDC)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::SetupPixelFormat(HDC hDC)
{
    PIXELFORMATDESCRIPTOR pfd;
	memset(&pfd, 0, sizeof(PIXELFORMATDESCRIPTOR));
	pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR);   
	pfd.nVersion = 1;
	pfd.dwFlags =  PFD_DOUBLEBUFFER |
	               PFD_SUPPORT_OPENGL |
				   PFD_DEPTH_DONTCARE |
	               PFD_DRAW_TO_WINDOW;
	pfd.iPixelType = PFD_TYPE_RGBA;
	pfd.cColorBits = 24;
	pfd.cDepthBits = 0;
	pfd.iLayerType = PFD_MAIN_PLANE;


    // Give user a chance to change the pfd structure
    CustomizePixelFormat(&pfd);

    int  pixelformat=0;
   // VERIFY(pixelformat=ChoosePixelFormat(hDC, &pfd));
	pixelformat = MyChoosePixelFormat(hDC, pfd);
    VERIFY(SetPixelFormat(hDC,pixelformat, &pfd));

}


//		   Name:	RegisterOpenGLWindowClass()
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

BOOL COpenGLControlBase::RegisterOpenGLWindowClass()
{ 
    WNDCLASS wcls;

    // If already registered, return
    if (::GetClassInfo(AfxGetInstanceHandle(),"OpenGL", &wcls))
         return TRUE;

    wcls.style=CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
    wcls.lpfnWndProc=(WNDPROC)::DefWindowProc;
    wcls.cbClsExtra=0;
    wcls.cbWndExtra=0;
    wcls.hInstance=AfxGetInstanceHandle();
    wcls.hIcon=::LoadIcon(NULL,IDI_APPLICATION);
    wcls.hCursor=::LoadCursor(NULL,IDC_ARROW);
    wcls.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
    wcls.lpszMenuName=NULL;
    wcls.lpszClassName="OpenGL";

    return AfxRegisterClass(&wcls); 
}


//		   Name:	InitializeOpenGLWindow() 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::InitializeOpenGLWindow()
{
	m_pDC = new CClientDC(this);
	SetupPixelFormat(m_pDC->GetSafeHdc( ) );
	//m_hRC = wglCreateContext(m_pDC->GetSafeHdc( ) );
	m_hRC = g_pManager->GetContext(m_pDC->GetSafeHdc());
	BeginOpenGLDrawing();
}


//		   Name:	UninitializeOpenGLWindow()
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::UninitializeOpenGLWindow()
{
	if (m_hRC)
    {   
        SetFocus();
		BeginOpenGLDrawing();
		vWindowDestroyed();
		EndOpenGLDrawing();

    //    wglMakeCurrent(NULL,NULL);
    //    wglDeleteContext(m_hRC);
    //    m_hRC=NULL;
    }
	if (m_pDC)
		delete m_pDC;	//Delete CClientDC so that ReleaseDC is called.
}





//		   Name:	OnLButtonDown(UINT nFlags, CPoint point)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnLButtonDown(UINT nFlags, CPoint point)
{
	m_bMousePressedInThisWindow  = true;
	point.y = m_nWindowHeight - point.y;
	m_cCurrentMouse.SetCoords(point);

	m_cCurrentMouse.SetEventButton(CMouseState::LeftButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));
	SetFocus();
	SetCapture();
	
	BeginOpenGLDrawing();
	vWindowMouseButtonPress(m_cCurrentMouse);
	EndOpenGLDrawing();
	
}


//		   Name:	OnLButtonUp(UINT nFlags, CPoint point)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnLButtonUp(UINT nFlags, CPoint point)
{
	point.y = m_nWindowHeight - point.y;
	m_cCurrentMouse.SetCoords(point);
	
	m_cCurrentMouse.SetEventButton(CMouseState::LeftButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));
	
	if (m_bMousePressedInThisWindow)
	{
		BeginOpenGLDrawing();
		vWindowMouseButtonRelease(m_cCurrentMouse);
		EndOpenGLDrawing();
	}
	if( !(nFlags & MK_LBUTTON) && !(nFlags & MK_MBUTTON) && !(nFlags & MK_RBUTTON))
	{
		ReleaseCapture( );
		m_bMousePressedInThisWindow  = false;
	}
}


//		   Name:	OnMButtonDown(UINT nFlags, CPoint point)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnMButtonDown(UINT nFlags, CPoint point)
{
	m_bMousePressedInThisWindow  = true;
	point.y = m_nWindowHeight - point.y;
	m_cCurrentMouse.SetCoords(point);

	m_cCurrentMouse.SetEventButton(CMouseState::MiddleButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));

	SetFocus();
	SetCapture();
	
	BeginOpenGLDrawing();
	vWindowMouseButtonPress(m_cCurrentMouse);
	EndOpenGLDrawing();
}


//		   Name:	OnMButtonUp(UINT nFlags, CPoint point)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnMButtonUp(UINT nFlags, CPoint point)
{
	point.y = m_nWindowHeight - point.y;
	m_cCurrentMouse.SetCoords(point);

	m_cCurrentMouse.SetEventButton(CMouseState::MiddleButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));
	
	if (m_bMousePressedInThisWindow)
	{
		BeginOpenGLDrawing();
		vWindowMouseButtonRelease(m_cCurrentMouse);
		EndOpenGLDrawing();
	}
	if( !(nFlags & MK_LBUTTON) && !(nFlags & MK_MBUTTON) && !(nFlags & MK_RBUTTON))
	{
		ReleaseCapture( );
		m_bMousePressedInThisWindow  = false;
	}
}


//		   Name:	OnMouseMove(UINT nFlags, CPoint point)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnMouseMove(UINT nFlags, CPoint point)
{
	point.y = m_nWindowHeight - point.y;
	CPoint cDelta = point - m_cCurrentMouse.GetCoords();
	m_cCurrentMouse.SetCoords(point);
	
	m_cCurrentMouse.SetEventButton(CMouseState::NoButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));

	if( m_bMousePressedInThisWindow  && 
							  ( m_cCurrentMouse.IsButtonDown(CMouseState::LeftButton)		||
								m_cCurrentMouse.IsButtonDown(CMouseState::MiddleButton)		||
								m_cCurrentMouse.IsButtonDown(CMouseState::RightButton)		||
								m_cCurrentMouse.IsShiftDown()								||
								m_cCurrentMouse.IsCntlDown()								||
								m_cCurrentMouse.IsAltDown()	) )
	{
		BeginOpenGLDrawing();
		vWindowMouseMotion(m_cCurrentMouse, cDelta);
		EndOpenGLDrawing();
	}
}


//		   Name:	OnSize(UINT nType, int cx, int cy) 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	m_nWindowWidth = cx;
	m_nWindowHeight = cy;
	
	if( !m_bInitialized)
		return;
	BeginOpenGLDrawing();
		glViewport(0,0,cx,cy);
		vWindowResized(cx, cy);
	EndOpenGLDrawing();
}


//		   Name:	OnRButtonUp(UINT nFlags, CPoint point) 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnRButtonUp(UINT nFlags, CPoint point) 
{
	point.y = m_nWindowHeight - point.y;
	m_cCurrentMouse.SetCoords(point);

	m_cCurrentMouse.SetEventButton(CMouseState::RightButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));
	
	if (m_bMousePressedInThisWindow)
	{
		BeginOpenGLDrawing();
		vWindowMouseButtonRelease(m_cCurrentMouse);
		EndOpenGLDrawing();
	}
	if( !(nFlags & MK_LBUTTON) && !(nFlags & MK_MBUTTON) && !(nFlags & MK_RBUTTON))
	{
		ReleaseCapture( );
		m_bMousePressedInThisWindow  = false;
	}
}


//		   Name:	OnRButtonDown(UINT nFlags, CPoint point) 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_bMousePressedInThisWindow  = true;
	point.y = m_nWindowHeight - point.y;
	m_cCurrentMouse.SetCoords(point);

	m_cCurrentMouse.SetEventButton(CMouseState::RightButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));

	SetFocus();
	SetCapture();

	BeginOpenGLDrawing();
	vWindowMouseButtonPress(m_cCurrentMouse);
	EndOpenGLDrawing();
}

//		   Name:	OnRButtonDblClk(UINT nFlags, CPoint point) 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	point.y = m_nWindowHeight - point.y;
	m_cCurrentMouse.SetCoords(point);

	m_cCurrentMouse.SetEventButton(CMouseState::RightButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));
	
	SetFocus();
	BeginOpenGLDrawing();
	vWindowMouseButtonDoublePress(m_cCurrentMouse);
	EndOpenGLDrawing();
}

//		   Name:	OnLButtonDblClk(UINT nFlags, CPoint point) 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	point.y = m_nWindowHeight - point.y;
	m_cCurrentMouse.SetCoords(point);
	m_cCurrentMouse.SetEventButton(CMouseState::LeftButton);

	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));
	
	SetFocus();
	BeginOpenGLDrawing();
	vWindowMouseButtonDoublePress(m_cCurrentMouse);
	EndOpenGLDrawing();
}

//		   Name:	OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CKeyState cKeyState;
	
	unsigned char cChar;
	m_cKeyMap.KeyUp(nChar, cChar);
	if (cChar == 255)
		return;
	
	cKeyState.SetKeyAsChar(cChar);
}

//		   Name:	OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CKeyState cKeyState;
	unsigned char cChar;
	if (m_cKeyMap.KeyDown(nChar, cChar))
	{
		cKeyState.SetKeyAsChar(cChar);
	}
	else
	{
		if (cChar == 255)
			return;
	//	vKeyRepeated(cChar, LOWORD(lParam));
//		printf("nChar = %d, cChar = %d\n", nChar, int(cChar));
		cKeyState.SetKeyAsChar(cChar);
	}

	BeginOpenGLDrawing();
	vWindowKeyboardHandler(cKeyState);
	EndOpenGLDrawing();
}


//		   Name:	IsAnimating()
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

bool	COpenGLControlBase::IsAnimating()			
{
	return (m_bAnimating);
}


//		   Name:	OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation
 
BOOL COpenGLControlBase::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	m_cCurrentMouse.SetButtonDown(CMouseState::LeftButton, (nFlags & MK_LBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::MiddleButton, (nFlags & MK_MBUTTON));
	m_cCurrentMouse.SetButtonDown(CMouseState::RightButton, (nFlags & MK_RBUTTON));

	pt.y = m_nWindowHeight - pt.y;
	CPoint cDelta = pt - m_cCurrentMouse.GetCoords();
	m_cCurrentMouse.SetCoords(pt);

	BeginOpenGLDrawing();
	vWindowMouseWheelMotion(m_cCurrentMouse, zDelta);
	EndOpenGLDrawing();
	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}


//		   Name:	CreatePopupMenu( char** pEntries, UINT nID)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::CreatePopupMenu( char** pEntries, UINT nID)
{
	m_cMenu.Add(pEntries, nID);
	CPoint cPoint = m_cCurrentMouse.GetCoords();
	cPoint.y = m_nWindowHeight - cPoint.y;
	m_cMenu.Show(cPoint);
}


//		   Name:	BeginOpenGLDrawing()
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::BeginOpenGLDrawing()
{
	wglMakeCurrent(NULL, NULL);
	if (m_pDC == NULL)
		m_pDC = new CClientDC(this);
	BOOL bResult = wglMakeCurrent(m_pDC->GetSafeHdc( ), m_hRC);	 
	if (!bResult)
		TRACE("wglMakeCurrent failed in COpenGLControlBase::BeginOpenGLDrawing()\n");

}


//		   Name:	EndOpenGLDrawing()
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::EndOpenGLDrawing()
{
//	wglMakeCurrent(NULL,NULL);
}

//		   Name:	EndOpenGLDrawing()
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

bool COpenGLControlBase::WindowDepthBufferChanged( )
{
	float fPixels[4];
	glReadPixels(m_cCurrentMouse.GetX( ), m_cCurrentMouse.GetY( ), 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT,
		fPixels);
	if (fPixels[0] != m_fLastDepth)
	{
		m_fLastDepth = fPixels[0];
		return true;
	}
	else
	{
		m_fLastDepth = fPixels[0];
		return false;
	}
}


//		   Name:	OnNcPaint()
//
//	Description:	This function is called when a window covering the window that the opengl drawing is being done in,
//				is moved and the OpenGL window must be completely redrawn.
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	05/20/99	Weaver		Creation

void COpenGLControlBase::OnNcPaint()
{
	BeginOpenGLDrawing();
		vWindowExposure();		//Call Exposure function
	EndOpenGLDrawing();
	CWnd::OnNcPaint();
}


//		   Name:	Draw()
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	05/20/99	Weaver		Creation

void	COpenGLControlBase::Draw()
{
	BeginOpenGLDrawing();
		
	vWindowDraw();	//Call Draw Function

	glFinish();

	if( !SwapBuffers(m_pDC->GetSafeHdc( ) ) )
	{
		string strTemp = "SwapBuffers failed:  ";
		strTemp += ::GetCurrentMessage();
//		printf("%s\n", strTemp.c_str());
	}
	glFinish();
	vWindowPostSwap();	//Call PostSwap Function
	EndOpenGLDrawing();
}





//		   Name:	OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
//
//	Description:
//
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CKeyState cKeyState;
	unsigned char cChar;
	if (m_cKeyMap.KeyDown(nChar, cChar))
	{
		cKeyState.SetKeyAsChar(cChar);
	}
	else
	{
		if (cChar == 255)
			return;
	//	vKeyRepeated(cChar, LOWORD(lParam));
	//	printf("nChar = %d, cChar = %d\n", nChar, int(cChar));
		cKeyState.SetKeyAsChar(cChar);
	}
	BeginOpenGLDrawing();
	vWindowKeyboardHandler(cKeyState);
	EndOpenGLDrawing();
}

//		   Name:	OnSysKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
//
//	Description:
// 
//
//		Version 	Date		Author		Comment	
//	   ----------- ----------- ----------- -----------
//		01.01.00	07/08/99	Weaver		Creation

void COpenGLControlBase::OnSysKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CKeyState cKeyState;
	
	unsigned char cChar;
	m_cKeyMap.KeyUp(nChar, cChar);
	if (cChar == 255)
		return;
	
	cKeyState.SetKeyAsChar(cChar);
}

void	COpenGLControlBase::PostUpdate()			
{
	NMHDR cHdr;
	cHdr.hwndFrom = m_hWnd;
	cHdr.code = m_nCode;
	GetParent()->SendMessage(WM_NOTIFY,(WPARAM)m_nCode,(LPARAM)&cHdr);							
}


void COpenGLManager::SetHardwareAccel(bool bFlag)
{
	m_bHardwareAccel = bFlag;
}

void COpenGLControlBase::OnTimer( UINT nIDEvent )
{

}