// CTrack Class Implementation
// 
// Description : handles drawing the track and collision with the walls
//

// includes
#include "stdafx.h"
#include "Track.h"

///////////////////////////////////////////////////////////////////
// CTrack::Update()
// Description:	does nothing now
//				in the future, we might have moving objects around the track
///////////////////////////////////////////////////////////////////
void CTrack::Update()
{
	
}

///////////////////////////////////////////////////////////////////
// CTrack::Draw()
// Description:	draw the track
///////////////////////////////////////////////////////////////////
void CTrack::Draw()
{
	glPushMatrix();
	glRotatef(180.0f, 0.0f, 0.0f, 1.0f);
	m_cTrackModel.Draw();
	glPopMatrix();
}

///////////////////////////////////////////////////////////////////
// CTrack::CheckColliding(CPnt &cCar)
// Description:	check to see if the point (car's position) is hitting a wall
//				returns which wall is hit
//					0 = NONE
//					1 = LEFT
//					2 = RIGHT
///////////////////////////////////////////////////////////////////
int CTrack::CheckColliding(CPnt &cCar)
{
	int nIsColliding = 0;

	if(cCar.data[0] < -660.0f)
	{
		if(((cCar.data[0] + 660.0f) * (cCar.data[0] + 660.0f) + cCar.data[1] * cCar.data[1]) > 105625.0f)
			nIsColliding = 2;
		else if(((cCar.data[0] + 660.0f) * (cCar.data[0] + 660.0f) + cCar.data[1] * cCar.data[1]) < 60025.0f)
			nIsColliding = 1;
	}
	else if(cCar.data[0] >= 660.0f)
	{
		if(((cCar.data[0] - 660.0f) * (cCar.data[0] - 660.0f) + cCar.data[1] * cCar.data[1]) > 105625.0f)
			nIsColliding = 2;
		else if(((cCar.data[0] - 660.0f) * (cCar.data[0] - 660.0f) + cCar.data[1] * cCar.data[1]) < 60025.0f)
			nIsColliding = 1;
	}
	else if(cCar.data[1] < 0.0f)
	{
		if(cCar.data[1] < -325.0f)
			nIsColliding = 2;
		else if(cCar.data[1] > -245.0f)
			nIsColliding = 1;
	}
	else if(cCar.data[1] > 0.0f)
	{
		if(cCar.data[1] > 325.0f)
			nIsColliding = 2;
		else if(cCar.data[1] < 245.0f)
			nIsColliding = 1;
	}

	return nIsColliding;
}